/*********************************************************
 * MOIRCS acquisition:
 *
 *    Calculate percentile
 *
 *       Input  : pData     : Array of data
 *       Input  : iNdata    : Number of data
 *       Input  : fPercent  : 
 *       Output :  :
 *
 *       Ver.1.0 : 20050915 : Masayuki Akiyama
 **********************************************************
 */

#include "acquisition.h"

float percentile(const float *pData, const int iNdata, const float fPercent)
{
int    iN1, iN2;
int    iMax;
float  fMax_data;
int    iN_median;
float  fPercentile;
float  *pData_sort;
 
   pData_sort = (float *)malloc(sizeof(float)*(iNdata));

   for(iN1=0;iN1<iNdata;iN1++){
      *(pData_sort+iN1) = *(pData+iN1);
   }

   iMax = 0;
   for(iN1=0;iN1<iNdata;iN1++){
      fMax_data = *(pData_sort+iN1);
      for(iN2=iN1+1;iN2<iNdata;iN2++){
         if(*(pData_sort+iN2)>fMax_data){
            fMax_data = *(pData_sort+iN2);
            iMax = iN2;
         }
      }
      *(pData_sort+iMax)=*(pData_sort+iN1);
      *(pData_sort+iN1)=fMax_data;
   }

   iN_median = ceil(iNdata*fPercent);
   fPercentile = *(pData_sort+iN_median);

   free( pData_sort );
   return  fPercentile;
}
