import string
from pyraf import iraf
from iraftool import fileutil

def mkdflat(infile, outfile, bpm,
           offfile='INDEF', normalize=10000,
           do_clean=False
           ):
    """
    infile: imput frame list
    outfile: output file name
    bpm:     badpixel mask
    offfile: off point file list
    normalize: normilization factor
    """
    if(os.access(fileutil.osimg(outfile), os.F_OK)): os.unlink(fileutil.osimg(outfile))
    cmbframe = "mkflat_cmbframe"
    nrcmbframe = "mkflat_nrcmbframe"
    fxframe = "mkflat_fxframe"
    offcmbframe = "mkflat_offcmbframe"
    sbcmbframe = "mkflat_sbcmbframe"
    if(os.access(fileutil.osimg(cmbframe), os.F_OK)): os.unlink(fileutil.osimg(cmbframe))
    if(os.access(fileutil.osimg(nrcmbframe), os.F_OK)): os.unlink(fileutil.osimg(nrcmbframe))
    if(os.access(fileutil.osimg(fxframe), os.F_OK)): os.unlink(fileutil.osimg(fxframe))
    if(os.access(fileutil.osimg(offcmbframe), os.F_OK)): os.unlink(fileutil.osimg(offcmbframe))
    if(os.access(fileutil.osimg(sbcmbframe), os.F_OK)): os.unlink(fileutil.osimg(sbcmbframe))
    
    inlist = fileutil.fileparse(infile)
    iraf.imcombine(string.join(inlist, ','), cmbframe, comb='median', outtype='real',
                   scale='exposure', zero='none', weight='none', expname='EXPTIME',
                   reject='sigclip', mclip=True, lsigma=3.0, hsigma=3.0)
    if offfile != 'INDEF':
        offlist = fileutil.fileparse(offfile)
        iraf.imcombine(string.join(offlist, ','), offcmbframe, comb='median', outtype='real',
                       scale='exposure', zero='none', weight='none', expname='EXPTIME',
                       reject='sigclip', mclip=True, lsigma=3.0, hsigma=3.0)
        iraf.imarith(cmbframe, '-', offcmbframe, sbcmbframe)
        if do_clean:
            if(os.access(fileutil.osimg(cmbframe), os.F_OK)): os.unlink(fileutil.osimg(cmbframe))
        cmbframe = sbcmbframe
    
    iraf.imarith(cmbframe, '/', normalize, nrcmbframe)
    _fixpix(nrcmbframe, fxframe, bpm)
    _quadcorr(fxframe, outfile)

    if do_clean:
        if(os.access(fileutil.osimg(cmbframe), os.F_OK)): os.unlink(fileutil.osimg(cmbframe))
        if(os.access(fileutil.osimg(nrcmbframe), os.F_OK)): os.unlink(fileutil.osimg(nrcmbframe))
        if(os.access(fileutil.osimg(fxframe), os.F_OK)): os.unlink(fileutil.osimg(fxframe))
        if(os.access(fileutil.osimg(offcmbframe), os.F_OK)): os.unlink(fileutil.osimg(offcmbframe))
        if(os.access(fileutil.osimg(sbcmbframe), os.F_OK)): os.unlink(fileutil.osimg(sbcmbframe))
