'''
tmpfile.py temporafy file utility for iraf
2007. 5. 14 YOSHIKAWA, Tomohiro
$Log: not supported by cvs2svn $
'''

import os
import __builtin__
from pyraf import iraf
import fileutil

class TmpFile:
    def __init__(self, root):
        self.path = iraf.osfn(iraf.mktemp("tmp$"+root))
        if not os.path.exists(os.path.dirname(self.path)):
            raise IOError, 'No such directory: '+os.path.dirname(self.path)

    def writelist(self, wlist, ext=False):
        """
        add wlist to tmpfile
        """
        tmpf = __builtin__.open(self.path, 'a')
        for line in wlist:
            if ext:
                tmpf.write('%s[%d]'%(line[0],line[1])+'\n')
            else:
                tmpf.write(line+'\n')
        tmpf.close()

    def append(self, name):
        """
        append name to tmpfile
        """
        tmpf = __builtin__.open(self.path, 'a')
        tmpf.write(name+'\n')
        tmpf.close()

    def list(self):
        """
        get list of file names in tmpfile
        """
        rlist = []
        for line in  __builtin__.open(self.path, 'r'):
            rlist.append(line.strip())
        return rlist

    def remove(self):
        """
        remove files in tmpfile
        """
        for file in self.list():
            fname = fileutil.osimg(file)
            if(os.access(fname, os.F_OK)): os.unlink(fname)
    
    def close(self):
        if(os.access(self.path, os.F_OK)): os.unlink(self.path)

def open(root):
    return TmpFile(root)
